<template>
    <div class="container">
      <div class="columns">
        <div class="column is-two-fifths">
            <figure class="image is-128x128">
              <img
                  class="photoEmployee"
                  :src="photo"
                  alt="Placeholder image"
              ></img>
            </figure>
            <b-field class="file is-info" >
              <b-upload v-model="file" class="file-label">
                 <span class="file-cta" >
                     <b-icon class="file-icon" icon="upload"></b-icon>
                     <span class="file-label">Añade una foto</span>
                 </span>
               </b-upload>
           </b-field>
        </div>
        <div class="column">
          <b-field label="Nombre">
            <b-input id="form-name" v-model="name"></b-input>
            </b-field>
          <b-field label="Apellidos">
            <b-input id="form-surname" v-model="surname"></b-input>
          </b-field>
          <div class="field">
            <b-checkbox v-model="access">
              Acceso
            </b-checkbox>
          </div>
        </div>
      </div>
      <nav class="level">
        <div class="level-left"></div>
        <div class="level-right">
          <b-button id="add-employee" type="is-info" outlined @click="sendEmployeeForm">{{ buttonText }}</b-button>
        </div>
      </nav>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex'
import {uploadFunction} from'../db/uploadImage'

export default {
  name: 'EmployeeForm',
  data() {
    return {
      id: '',
      file: {},
      photo: '',
      name: '',
      surname: '',
      access: false,
      buttonText: "Crear",
     }
  },
  computed: {
      ...mapGetters({
        activeCard: 'getActiveCard'
      }),
  },
  methods: {
    ...mapActions(['addEmployee', 'editEmployee']),
    setDefaultValues() {
      this.id = '',
      this.file = {}
      this.photo = ""
      this.name = ''
      this.surname = ''
      this.access = false
      this.buttonText = "Crear"
    },
    sendEmployeeForm() {
        const employeeInformation = {
          id: this.id,
          name: this.name,
          surname: this.surname,
          access: this.access,
          photo: this.photo
        }
        if(this.buttonText === "Crear") {
          this.addEmployee(employeeInformation)
        } else if (this.buttonText === "Modificar") {
          this.editEmployee(employeeInformation)
        }

        this.setDefaultValues()
    },
  },
  watch: {
    activeCard(newActiveCard) {
      if (newActiveCard === '') { this.setDefaultValues() }
      this.id = newActiveCard.id
      this.photo = newActiveCard.photo
      this.name = newActiveCard.name
      this.surname = newActiveCard.surname
      this.access = newActiveCard.access
      this.buttonText = "Modificar"
    },
    file(newFile) {
      if (newFile.name) {
        uploadFunction(newFile, downloadURL => {
            this.photo = [downloadURL]
          })
      }
    }
  }
}
</script>

<style lang="scss">
  .container {
    border:0.1rem solid;
    border-radius: 0.5rem;
    padding: 1rem;
  }
  .image {
    margin:auto;
  }
  .upload {
    margin:auto;
  }

</style>
